function bmscex44
% In this exercise we simulate BM via path refinement
% T= final time
T = 1;  
% number of refinements
% (you might understand the code better if you set L=1, i.e., only one refinement step)
L= 8;
%N0=number of grid points on the first level
N0 =10;
%N= number of grid points on the final level
N = N0*2^L;
% Brownian motion at each refinement step (initalize)
EMX = zeros(L+1, N+1);
% timestep
h= T/N;
% path of Brownian motion at first level cf. Ex2-4
B = [zeros(1,1);sqrt(T/N0)*cumsum(randn(N0,1))];
EMX(1, 1:2^L:end) = B;

% time on the last level
t = (T*(0:N)'/N);
% plot first picture

subplot(3,3,1); plot((T*(0:N0)'/N0), B); 

% refine the brownian path
  for i=2:L+1             
      p = 2^(L-i+1);
      EMX(i,:)=EMX(i-1,:);
      % new step size
      h= T/(N0*2^(i-1));
      % number of new random variables needed
      len=N/p/2;
      % simulate the BM value at midpoint (t_i+t_(i+1))/2 given the values
      % at t_i and t_(i+1)
      % Since BM is a gaussian process, we have that for u<s<t with
      % u-s=t-s=h the random variable B_s | (B_u=a and B_t=b) is again
      % gaussian with mean (a+b)/2 and variance h/2 
     EMX(i, [p+1:2*p: N+1-p])= .5*(EMX(i,[1:2*p: N+1-2*p])+EMX(i,[2*p+1:2*p: N+1]))+...
         sqrt(h./2)*randn(1,len);
    % plot the refined BM
   subplot(3,3,i); plot(t(1:p:N), EMX(i, 1:p:N)');    
  end

end